<?PHP
// 01-Shoutbox - http://www.01-scripts.de/shoutbox.php
// Open Source (Code): https://github.com/01-Scripts/01-Shoutbox
//		be free to create a fork of it!

/*
The MIT License

Copyright (c) 2011 Michael Lorer - 01-Scripts.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

// KONFIGURATION

// MySQL-Einstellungen:
$host = "localhost";                  //Host/Server ihrer Mysql-Datenbank
$database = "test5";                       //Datenbankname
$user = "user";                           //Usernamen für Mysql-Datenbank
$passw = "";                          //Passwort zur Mysql-Datenbank

// Weitere Einstellungen:
$smilies = 1;                         //Smilies aktivieren? (1|0)
$pass = "admin";                      //Passwort zum Löschen & Bearbeiten von Einträgen
$break = 30;                          //Nach wie vielen Zeichen sollen Wörter umgebrochen werden?
$spamm = 5;                         //Spamzeit in Sekunden (wieviel Zeit muss zwischen einzelnen Posts vergehen?)
$limit = 5;                           //Wieviele Posts (pro Seite)?
$spam_schutz = 0;                     //Spam-Schutz (Rechenaufgabe) aktivieren ? (1|0)

/* WICHTIGER HINWEIS BEI AKTIVIERTEM SPAMSCHUTZ:
   Wenn Sie den Spamschutz aktivieren, müssen Sie folgenden PHP-Code
   GANZ AM ANFANG Ihrer Internetseite VOR jeglicher Ausgabe
   einfügen:
	   <?PHP
	   session_start();
	   ?>
   Anderenfalls erhalten Sie folgende Fehlermeldung:
   Warning: session_start() [function.session-start]: Cannot send session cache limiter - headers already sent (output started at ... )
*/

// Normalerweise keine Änderungen nötig:
$mysql_table['shoutbox'] = "01_shout";//MySql-Tabellename
$picpf = "smilies";                   //Pfad zum Smilie-Verzeichnis
@date_default_timezone_set("Europe/Berlin");
error_reporting(E_ALL);

// KONFIGURATION BEENDET









$errorC = TRUE;
$filename = $_SERVER['PHP_SELF'];
if(!isset($_GET['site'])) $_GET['site'] = 1;

// FUNKTIONEN

// Smiliecodes ersetzen
function shout01_smilies($text){
	global $picpf;
	
	$text = str_replace(":)", "<img src=\"".$picpf."/1.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":D", "<img src=\"".$picpf."/2.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace("8)", "<img src=\"".$picpf."/3.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":eek:", "<img src=\"".$picpf."/4.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":p", "<img src=\"".$picpf."/5.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":(", "<img src=\"".$picpf."/6.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":x", "<img src=\"".$picpf."/7.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":oX:", "<img src=\"".$picpf."/8.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(":roll", "<img src=\"".$picpf."/9.gif\" alt=\"Smilie\" border=\"0\" />", $text);
	$text = str_replace(";)", "<img src=\"".$picpf."/10.gif\" alt=\"Smilie\" border=\"0\" />", $text);

	return $text;
	}
	
// Fügt weitere Parameter an einen übergeben Link an (es wird herausgefunden, ob zuerst ? oder & verwendet werden muss)
/*$links			Link, an den der Parameter angehängt werden soll
  $parameter		Ohne den ersten Parameter-Trenner (also ohne ? oder & am Anfang) Bei mehreren Parameter aber schon verwenden
  $js				Soll ein Link für eine Javascript-Funktion generiert werden? (& statt &amp;)

RETURN: Link inkl. angehängter Parameter
  */
function shout01_addParameter2Link($link,$parameter,$js=false){

if($js) $amp = "&";
else $amp = "&amp;";

if(strchr($link,"?"))
	return $link.$amp.$parameter;
else
	return $link."?".$parameter;

}

// Connect to MySQL-DB
$db = @mysql_connect($host, $user, $passw)
or die ("Verbindungsaufnahme mit der MySQL-Server war <b>nicht</b> erfolgreich!<br />Bitte gehen Sie nochmals zurück.<br />Sollte weiterhin keine Verbindung zum MySQL-Server zu Stande kommen wenden Sie sich an den technischen Ansprechparnter");
@mysql_select_db($database, $db)
or die ("Verbindungsaufnahme mit Datenbank war <b>nicht</b> erfolgreich!<br />Bitte gehen Sie nochmals zurück.<br />Sollte weiterhin keine Verbindung zur MySQL-Datenbank zu Stande kommen wenden Sie sich an den technischen Ansprechparnter");
// Connect!!ED!! to MySQL-DB




echo "<div id=\"shoutbox01\">\n";



// INSTALLATION

// MySQL-Tabelle anlegen, wenn sie noch nicht existiert:
if(!mysql_num_rows( mysql_query("SHOW TABLES LIKE '".$mysql_table['shoutbox']."'"))){
    $install_query = "CREATE TABLE ".$mysql_table['shoutbox']." (
    `id` int(10) NOT NULL auto_increment,
    `username` varchar(50) NOT NULL default '',
    `nachricht` text NOT NULL default '',
    `time` int(20) NOT NULL default '0',
    `ip` varchar(20) default NULL,
    `uid` varchar(32) NOT NULL default '',
    PRIMARY KEY (`id`)
    ) ENGINE=MyISAM AUTO_INCREMENT=1;";

    if(mysql_query($install_query)) echo "MySQL-Tabelle '".$mysql_table['shoutbox']."' wurde erfolgreich angelegt";
    else echo "Beim Anlegen der MySQL-Tabelle '".$mysql_table['shoutbox']."' trat ein Fehler auf. Die Tabelle konnte nicht angelegt werden";
    }
    
    
    
    
    
    

	
// Seiten-Funktion:
$mengequery = mysql_query("SELECT id FROM ".$mysql_table['shoutbox']."");
$menge = mysql_num_rows($mengequery);
if(isset($_GET['action']) && $_GET['action'] == "massdel") $limit = 25;
$maxsites = ceil($menge/$limit);

if(isset($_GET['site']) && !empty($_GET['site']) && $_GET['site'] != 0){
    $l1 = $_GET['site']*$limit;
    $l1 = $l1-$limit;
    $mysqllimit = " LIMIT ".$l1.",".$limit."";

    if($_GET['site'] > 1) $zl = $_GET['site']-1;
    if($_GET['site'] < $maxsites) $vl = $_GET['site']+1;
    }
else{
    $mysqllimit = " LIMIT ".$limit."";

    $zl = 0;
    if($menge > $limit) $vl = 2;
    }
    
$postquery = "SELECT * FROM ".$mysql_table['shoutbox']." ORDER BY time DESC".$mysqllimit."";





// Löschen bei korrektem Passwort
if(isset($_POST['action']) && $_POST['action'] == "admindel" && $_POST['passfeld'] == $pass && isset($_POST['id']) && !empty($_POST['id'])){
    mysql_query("DELETE FROM ".$mysql_table['shoutbox']." WHERE id='".mysql_real_escape_string($_POST['id'])."' LIMIT 1");

	echo "<p class=\"textmeldung_success\">Eintrag wurde gel&ouml;scht</p>
	<p class=\"textmeldung\"><a href=\"javascript:window.close();\">Fenster schlie&szlig;en</a></p>";
    }
// Massen-Löschen bei korrektem Passwort
elseif(isset($_POST['action']) && $_POST['action'] == "adminmassdel" && $_POST['passfeld'] == $pass){
	$cup = 0;
	$posts = mysql_query("SELECT id FROM ".$mysql_table['shoutbox']."");
	while($row = mysql_fetch_assoc($posts)){
		if(isset($_POST['del_'.$row['id']]) && $_POST['del_'.$row['id']] == 1){
			mysql_query("DELETE FROM ".$mysql_table['shoutbox']." WHERE id='".$row['id']."' LIMIT 1");
			$cup++;
			}
		}
	
	echo "<p class=\"textmeldung_success\">".$cup." Eintr&auml;ge wurde gel&ouml;scht</p>
	<p class=\"textmeldung\"><a href=\"javascript:window.close();\">Fenster schlie&szlig;en</a></p>";
    }
// Bearbeiten bei korrektem Passwort
elseif(isset($_POST['action']) && $_POST['action'] == "adminedit" && $_POST['passfeld'] == $pass && isset($_POST['id']) && !empty($_POST['id']) && is_numeric($_POST['id']) && isset($_POST['name']) && !empty($_POST['name']) && isset($_POST['nachricht']) && !empty($_POST['nachricht'])){
    mysql_query("UPDATE ".$mysql_table['shoutbox']." SET
	            username	='".mysql_real_escape_string(htmlspecialchars($_POST['name']))."', 
				nachricht	='".mysql_real_escape_string(htmlspecialchars($_POST['nachricht']))."' 
				WHERE id	='".mysql_real_escape_string($_POST['id'])."' LIMIT 1");
?>
	<script type="text/javascript">
	opener.window.location.reload();
	window.close();
	</script>
	<p class="textmeldung_success">Eintrag wurde bearbeitet</p>
	<p class="textmeldung"><a href="javascript:window.close();">Fenster schlie&szlig;en</a></p>
<?PHP
    }
elseif(isset($_REQUEST['action']) && !empty($_REQUEST['action']) && isset($_POST['passfeld']) && $_POST['passfeld'] != $pass){
	echo "<p class=\"textmeldung_failed\">Sie haben ein falsches Passwort eingegeben!</p>
	<p class=\"textmeldung\"><a href=\"javascript:history.back();\">Zur&uuml;ck</a></p>";
	}



// Löschen (Abfrage-Dialog)
if(isset($_GET['action']) && $_GET['action'] == "del" && isset($_GET['id']) && !empty($_GET['id']) && is_numeric($_GET['id'])){
?>
	<form action="<?PHP echo $filename; ?>" method="post">
	<p class="textmeldung">
	<a href="<?PHP echo shout01_addParameter2Link("shout.php","action=massdel"); ?>">Mehrere Eintr&auml;ge l&ouml;schen?</a><br />
	<br />
	
    <strong>Passwort:</strong><br />
    <input type="hidden" name="action" value="admindel" />
	<input type="hidden" name="id" value="<?PHP echo $_GET['id']; ?>" />
    
	<input type="password" name="passfeld" size="20" /><br />
	<input type="submit" value="L&ouml;schen" class="input_submit" /><br />
    <br />
	
	<a href="javascript:window.close();">Fenster schlie&szlig;en</a>
    </p>
	</form>
<?PHP
	}
// Mehrere Einträge löschen (Auswahl)
elseif(isset($_GET['action']) && $_GET['action'] == "massdel"){
?>
	<form action="shout.php" method="get">
	<input type="hidden" name="action" value="massdel" />
	
	<p class="textmeldung">
	Gew&uuml;nschte Eintr&auml;ge ausw&auml;hlen, Passwort eingeben und Forumlar absenden.<br />
	Es erfolgt <strong>KEINE weitere Sicherheitsabfrage!</strong><br />
	Alternativ: Andere Seite ausw&auml;hlen:
	<select name="site" size="1" onchange="location.href=this.value;">
		<?PHP
		for($x=1;$x<=$maxsites;$x++){
			if($x == $_GET['site']) echo "<option selected=\"selected\">".$x."</option>";
			else echo "<option value=\"".shout01_addParameter2Link($filename,"action=massdel&amp;site=".$x."")."\">".$x."</option>";
			}
		?>
	</select>
	</p>
	</form>
	
	<form action="shout.php" method="post">
    <input type="hidden" name="action" value="adminmassdel" />

	<div class="frame_del">
	<ul>
<?PHP
	$massdelquery = "SELECT id,username,nachricht,time FROM ".$mysql_table['shoutbox']." ORDER BY time DESC".$mysqllimit."";
	$posts = mysql_query($massdelquery);
	while($row = mysql_fetch_assoc($posts)){
		echo "<li><input type=\"checkbox\" name=\"del_".$row['id']."\" value=\"1\">
			  <a href=\"#\" title=\"".stripslashes($row['nachricht'])."\"><strong>".stripslashes($row['username'])."</strong></a> -
			  <i>".date("d.m.Y - H:i",$row['time'])."</i></li>";
		}
?>	
	</ul></div>
	
	<p class="textmeldung">
	
    <b>Passwort:</b><br />    
	<input type="password" name="passfeld" size="20" /><br />
	<input type="submit" value="L&ouml;schen" class="input_submit" /><br />
    <br />
	
	<a href="javascript:window.close();">Fenster schlie&szlig;en</a>
    </p>
	</form>
<?PHP
	}

//Bearbeiten
if(isset($_GET['action']) && $_GET['action'] == "edit" && isset($_GET['id']) && !empty($_GET['id']))
    {
    $posts = mysql_query("SELECT * FROM ".$mysql_table['shoutbox']." WHERE id='".mysql_real_escape_string($_GET['id'])."' LIMIT 1");
    while($rowp = mysql_fetch_assoc($posts))
        {
        echo "<form action=\"shout.php\" method=\"post\"><p class=\"textmeldung\">";
        echo "<b>Passwort:</b><br /><input type=\"password\" name=\"passfeld\" size=\"20\" />";
        echo "<br /><b>Name:</b><br /><input type=\"text\" value=\"".stripslashes($rowp['username'])."\" name=\"name\" size=\"30\" />";
        echo "<br /><b>Text:</b><br /><input type=\"text\" value=\"".stripslashes($rowp['nachricht'])."\" name=\"nachricht\" size=\"30\" />";

        echo "<br /><input type=\"submit\" value=\"Bearbeiten\" class=\"input_submit\" />";
        echo "<input type=\"hidden\" name=\"action\" value=\"adminedit\" /><input type=\"hidden\" name=\"id\" value=\"".$_GET['id']."\" />";

        echo "<br /><br /><a href=\"javascript:window.close();\">Fenster schlie&szlig;en</a>";
        echo "</p></form>";
        }
    }

//Eintragen von neuen Posts
if(isset($_POST['send']) && $_POST['send'] == 1 && isset($_POST['post']) && !empty($_POST['post']) && 
   isset($_POST['name']) && !empty($_POST['name']) && $_POST['name'] != "Name"){
    //Spamschutz
    if(!empty($_POST)){
        if(!isset($_SESSION['secCheck']) || !isset($_POST['secCheck'])) $errorC = TRUE;

        if(isset($_SESSION['secCheck']) && isset($_POST['secCheck']) && $_SESSION['secCheck'] != md5($_POST['secCheck'])) $errorC = TRUE;
        else $errorC = FALSE;
		}

    //Überprüfung der Spammtime & IP & UID
    $aktime = time()-$spamm;
    $checkentry = mysql_query("SELECT * FROM ".$mysql_table['shoutbox']." WHERE uid='".mysql_real_escape_string($_POST['uid'])."' OR time>='".$aktime."' AND ip='".mysql_real_escape_string($_SERVER['REMOTE_ADDR'])."'");
    $checkentry2 = mysql_num_rows($checkentry);

    if($checkentry2 < 1 && !$errorC && $spam_schutz == 1 OR $checkentry2 < 1 && $spam_schutz == 0){
        $sql_insert = "INSERT INTO ".$mysql_table['shoutbox']." (username,nachricht,time,ip,uid) VALUES ('".mysql_real_escape_string(htmlspecialchars($_POST['name']))."', '".mysql_real_escape_string(htmlspecialchars($_POST['post']))."', '".time()."', '".$_SERVER['REMOTE_ADDR']."', '".mysql_real_escape_string($_POST['uid'])."')";
        $result = mysql_query($sql_insert, $db);
        }
    else $spammtime = 1;
    }
?>

<script type="text/javascript">
function popup(id, action) {
	window.open('<?PHP echo basename($filename); ?>?id='+id+'&action='+action+'','_blank','width=250,height=200,scrollbars=yes,resizable=yes,status=no,toolbar=no,left=200,top=150');
	}

function smilie_sb(text){
	eval("document.shoutbox.post.value += \""+text+"\"");
	}

function clearField(field){
	if(field.value == field.defaultValue){
	    field.value = "";
	    }
	}

function checkField(field){
	if(field.value == ""){
	    field.value = field.defaultValue;
	    }
	}
</script>







<?PHP
if(!isset($_GET['action']) && !isset($_POST['action'])){
?>



<!--Ausgabe der Beiträge-->
<div class="shout01_entries">
	<?PHP
	//Ausgabe der Meldung, wenn die Spammtime noch nicht abgelaufen ist:
	if(isset($spammtime)){
	    echo "<p class=\"textmeldung_failed\">Spamschutz: Bitte die Gleichung berechnen!<br />
		Es kann nur alle ".$spamm."s ein Beitrag erstellt werden!</p>";
	    }
	
	echo "<ul class=\"shout01_entries\">\n";
	$posts = mysql_query($postquery);
	while($rowp = mysql_fetch_assoc($posts)){
	    $datum = date("d.n - G:i",$rowp['time']);
	
	    $string = stripslashes($rowp['nachricht']);
	    $string = wordwrap($string , $break , "<br />" , 1);
	    $string = preg_replace('"( |^)(www.[-a-zA-Z0-9@:%_\+.~#?&//=]+)"i','\\1<a href="http://\2" target="_blank">\\2</a>', $string);
	    if($smilies == 1) $string = shout01_smilies($string);
	
	    $nbreak = wordwrap($rowp['username'] , $break , "-<br />" , 1);
	
	    echo "<li>";
		echo "<a href=\"javascript:popup(".$rowp['id'].", 'edit')\" style=\"color:green; text-decoration:none;\">&euro;</a> ";
	    echo "<a href=\"javascript:popup(".$rowp['id'].", 'del')\" style=\"color:red; text-decoration:none;\">x</a> ";
	    echo "<i>".$datum."</i> <b>".$nbreak.":</b><br />".$string;
	    echo "</li>\n";
	    }
	?>
	</ul>
</div>

<div class="pages_01shout">
	<?PHP if($_GET['site'] > 1){ echo "<a href=\"".shout01_addParameter2Link($filename,"site=1")."\"><b>&laquo; 1</b></a>"; }else{ echo "&nbsp;"; } ?>
	&nbsp;<?PHP if(isset($zl) && $zl > 0){ echo "<a href=\"".shout01_addParameter2Link($filename,"site=".$zl)."\"><b>&lt; ".$zl."</b></a>"; } ?>
	<?PHP if(isset($vl) && $vl <= $maxsites){ echo "<a href=\"".shout01_addParameter2Link($filename,"site=".$vl)."\"><b>".$vl." &gt;</b></a>"; } ?>&nbsp;
	<?PHP if(isset($_GET['site']) && $_GET['site'] < $maxsites OR (isset($vl) && $vl == 2)){ echo "<a href=\"".shout01_addParameter2Link($filename,"site=".$maxsites)."\"><b>".$maxsites." &raquo;</b></a>"; }else{ echo "&nbsp;"; } ?>
</div>
<!--ENDE: Ausgabe der Beiträge-->







<!--Ausgabe des Formulars-->
<form action="<?PHP echo $filename; ?>" name="shoutbox" method="post">
<div class="newentry_01shout">
	<input type="text" name="name" value="<?PHP if(isset($_POST['name']) && !empty($_POST['name'])){ echo $_POST['name']; }else{ echo "Name"; } ?>" onfocus="clearField(this);" onblur="checkField(this);" class="input_text" />
    <input type="text" value="<?PHP if(isset($_POST['post']) && !empty($_POST['post'])){ echo $_POST['post']; }else{ echo "Nachricht"; } ?>" name="post" onfocus="clearField(this);" onblur="checkField(this);" class="input_text" />

<?PHP if($smilies == 1){ ?>
	<br />
	<a href="javascript:smilie_sb(' :) ');"><img src="<?PHP echo $picpf; ?>/1.gif" alt="Smilie :)" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :D ');"><img src="<?PHP echo $picpf; ?>/2.gif" alt="Smilie :D" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' 8) ');"><img src="<?PHP echo $picpf; ?>/3.gif" alt="Smilie 8)" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :eek: ');"><img src="<?PHP echo $picpf; ?>/4.gif" alt="Smilie :eek:" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :p ');"><img src="<?PHP echo $picpf; ?>/5.gif" alt="Smilie :p" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :( ');"><img src="<?PHP echo $picpf; ?>/6.gif" alt="Smilie :(" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :x ');"><img src="<?PHP echo $picpf; ?>/7.gif" alt="Smilie :x" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :oX: ');"><img src="<?PHP echo $picpf; ?>/8.gif" alt="Smilie :oX:" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' :roll ');"><img src="<?PHP echo $picpf; ?>/9.gif" alt="Smilie :roll" style="border: 0;" /></a>
	<a href="javascript:smilie_sb(' ;) ');"><img src="<?PHP echo $picpf; ?>/10.gif" alt="Smilie ;)" style="border: 0;" /></a>

<?PHP } ?>

<?PHP
if($spam_schutz == 1){
    //Spamschutz
    mt_srand((double)microtime() * 1000000);
    $oprand = mt_rand(1,3);

    switch($oprand){
        case 1:
          $gl1 = mt_rand(1,20); 
          $op = " &amp; "; 
          $gl2 = mt_rand(1,10); 
          $loesungmd5 = md5($gl1+$gl2);
        break;
        case 2:
          $gl1 = mt_rand(10,30);
          $op = " m|nus ";
          $gl2 = mt_rand(1,$gl1);
          $loesungmd5 = md5($gl1-$gl2);
        break;
        case 3:
          $gl1 = mt_rand(2,10);
          $op = " m@l ";
          $gl2 = mt_rand(2,6);
          $loesungmd5 = md5($gl1*$gl2);
        break;
        }
    $_SESSION['secCheck'] = $loesungmd5;
?>
	<?PHP echo $gl1.$op.$gl2; ?> <input type="text" value="Spamschutz =" name="secCheck" onfocus="clearField(this);" onblur="checkField(this);" class="input_text" />
<?PHP
    }//Ende: Spamschutz
?>
<br />
<?PHP
mt_srand((double)microtime() * 1000000);
$uidzufall = mt_rand(1,9999);
?>
<input type="hidden" name="uid" value="<? echo md5($_SERVER['REMOTE_ADDR'].time().$uidzufall); ?>" />
<input type="hidden" name="send" value="1" />
<input type="submit" value="Abschicken" class="input_submit" />

</div>
</form>
<!--Ausgabe des Formulars ENDE-->

<?PHP
}
?>
